const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Etapas_ou_trechosDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const etapas_ou_trechos = await db.etapas_ou_trechos.create(
      {
        id: data.id || undefined,

        tipo: data.tipo || null,
        nome: data.nome || null,
        descricao: data.descricao || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await etapas_ou_trechos.setObra(data.obra || null, {
      transaction,
    });

    await etapas_ou_trechos.setClientes(data.clientes || null, {
      transaction,
    });

    return etapas_ou_trechos;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const etapas_ou_trechosData = data.map((item, index) => ({
      id: item.id || undefined,

      tipo: item.tipo || null,
      nome: item.nome || null,
      descricao: item.descricao || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const etapas_ou_trechos = await db.etapas_ou_trechos.bulkCreate(
      etapas_ou_trechosData,
      { transaction },
    );

    // For each item created, replace relation files

    return etapas_ou_trechos;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const etapas_ou_trechos = await db.etapas_ou_trechos.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.tipo !== undefined) updatePayload.tipo = data.tipo;

    if (data.nome !== undefined) updatePayload.nome = data.nome;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    updatePayload.updatedById = currentUser.id;

    await etapas_ou_trechos.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await etapas_ou_trechos.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await etapas_ou_trechos.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return etapas_ou_trechos;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const etapas_ou_trechos = await db.etapas_ou_trechos.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of etapas_ou_trechos) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of etapas_ou_trechos) {
        await record.destroy({ transaction });
      }
    });

    return etapas_ou_trechos;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const etapas_ou_trechos = await db.etapas_ou_trechos.findByPk(id, options);

    await etapas_ou_trechos.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await etapas_ou_trechos.destroy({
      transaction,
    });

    return etapas_ou_trechos;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const etapas_ou_trechos = await db.etapas_ou_trechos.findOne(
      { where },
      { transaction },
    );

    if (!etapas_ou_trechos) {
      return etapas_ou_trechos;
    }

    const output = etapas_ou_trechos.get({ plain: true });

    output.obra = await etapas_ou_trechos.getObra({
      transaction,
    });

    output.clientes = await etapas_ou_trechos.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.tipo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('etapas_ou_trechos', 'tipo', filter.tipo),
        };
      }

      if (filter.nome) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('etapas_ou_trechos', 'nome', filter.nome),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'etapas_ou_trechos',
            'descricao',
            filter.descricao,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.etapas_ou_trechos.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('etapas_ou_trechos', 'nome', query),
        ],
      };
    }

    const records = await db.etapas_ou_trechos.findAll({
      attributes: ['id', 'nome'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['nome', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.nome,
    }));
  }
};
